class VECINT
{
	int coeff[16];
public:
	VECINT()
	{
		for(int i=0;i<16;i++)
			coeff[i] = 0;
	}
	VECINT(int j)
	{
		for(int i=0;i<16;i++)
			coeff[i] = j;
	}
	int& operator[](int i)
	{
		return coeff[i];
	}
	VECINT operator=(VECINT &c)
	{
		for(int i=0;i<16;i++)
			coeff[i] = c.coeff[i];
		return *this;
	}
	VECINT operator+(VECINT &c)
	{
		VECINT tmp;
		for(int i=0;i<16;i++)
			tmp.coeff[i] = coeff[i]+c.coeff[i];
		return tmp;
	}
	VECINT operator-(VECINT &c)
	{
		VECINT tmp;
		for(int i=0;i<16;i++)
			tmp.coeff[i] = coeff[i]-c.coeff[i];
		return tmp;
	}
	VECINT operator-()
	{
		VECINT tmp;
		for(int i=0;i<16;i++)
			tmp.coeff[i] = -coeff[i];
		return tmp;
	}
	VECINT operator*(double x)
	{
		VECINT tmp;
		for(int i=0;i<16;i++)
			tmp.coeff[i] = coeff[i] * x;
		return tmp;
	}
	VECINT operator>>(int y)
	{
		VECINT tmp;
		for(int i=0;i<16;i++)
			tmp.coeff[i] = coeff[i] >> y;
		return tmp;
	}
	VECINT operator>>=(int y)
	{
		for(int i=0;i<16;i++)
			coeff[i] = coeff[i] >> y;
		return *this;
	}
	VECINT operator<<(int y)
	{
		VECINT tmp;
		for(int i=0;i<16;i++)
			tmp.coeff[i] = coeff[i] << y;
		return tmp;
	}
	double getnorm()
	{
		double norm=0;
		for(int i=0;i<16;i++)
			norm += coeff[i] * coeff[i];
		return sqrt(norm);
	}
	void print()
	{
		for(int i=0;i<16;i++)
			printf("%5d ", (int)(coeff[i]));
		printf("\n");
	}
};
VECINT operator*(int x, VECINT yy)
{
	VECINT tmp;
	for(int i=0; i<16; i++)
		tmp[i] = yy[i] * x;
	return tmp;
}
void vrfy_mtrx_bstOdd16x16()
{
	VECINT tmp, tmp0, tmp00, tmp000, tmp0000, tmp0001, tmp001, tmp0010, tmp0011, tmp01, tmp010, tmp0100, tmp0101, 
				 tmp011, tmp0110, tmp0111, tmp1, tmp10, tmp100,
				 tmp1000, tmp1001, tmp101, tmp1010, tmp1011, tmp11, tmp110, tmp1100, tmp1101, tmp111, tmp1110, tmp1111;
	VECINT A00, A01, A02, A03, A04, A05, A06, A07, A08, A09, A10, A11, A12, A13, A14, A15, AL[16];
	VECINT x00, x01, x02, x03, x04, x05, x06, x07, x08, x09, x10, x11, x12, x13, x14, x15;
	VECINT x16, x17, x18, x19, x20, x21, x22, x23, x24, x25, x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37, x38, x39, x40, x41, x42, x43, x44, x45,
				x46, x47, x48, x49, x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61, x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73, x74, x75,
				x76, x77, x78, x79, x80, x81, x82, x83, x84, x85, x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97, x98, x99, x100, x101, x102, x103, x104,
				x105, x106, x107, x108, x109, x110, x111, x112, x113, x114, x115, x116, x117, x118, x119, x120, x121, x122, x123, x124, x125, x126, x127;
	x00[ 0] = 1;	x01[ 1] = 1;	x02[ 2] = 1;	x03[ 3] = 1;
	x04[ 4] = 1;	x05[ 5] = 1;	x06[ 6] = 1;	x07[ 7] = 1;
	x08[ 8] = 1;	x09[ 9] = 1;	x10[10] = 1;	x11[11] = 1;
	x12[12] = 1;	x13[13] = 1;	x14[14] = 1;	x15[15] = 1;

	//code start
	A02 = (x00<<7);
	A04 = (x00<<1);
	A07 = -(x00);
	A10 = (x00<<6);
	A11 = (x00<<5);
	A14 = -(x00<<1) + (x00<<4);

	A05 = -(x01 + (x01<<2));
	A08 = -((x01<<7));
	A10 = A10 - x01;

	A00 = (x02<<3);
	A02 = A02 + (x02<<4);
	A04 = A04 - x02;
	A10 = A10 - (x02<<3);
	A13 = (x02<<7);


	A03 = x04;
	A05 = A05 - (x04<<2);
	A11 = A11 - (x04<<1);
	A13 = A13 + (x04<<6);

	A00 = A00 - (x05<<1);
	tmp1 = x05 + (x05<<3);
	A03 = (A03 - tmp1);
	A13 = A13 - (x05<<6);

	A03 = A03 + x06;
	A09 = -(x06);
	A11 = A11 - x06;

	A02 = A02 + (x07<<3);
	A04 = A04 + (x07<<1);
	A06 = -((x07<<2) + (x07<<7));
	A07 = A07 + (x07<<1);
	A08 = A08 + (x07<<3);
	A12 = (x07<<7);

	A07 = A07 + (x08<<7);
	A13 = A13 - (x08<<5);

	A01 = -((x09<<7));
	A03 = A03 + (x09<<2);
	A13 = A13 + (x09<<6);
	A15 = -(x09 + (x09<<5));

	A01 = A01 - (x10<<2);
	A13 = A13 + (x10<<3);

	A06 = A06 + x11;
	A08 = A08 + (x11<<6);
	A12 = A12 - (x11<<7);
	A15 = A15 - (x11<<4);

	A07 = A07 + x12;

	A02 = A02 - (x13<<2);
	A04 = A04 + (x13<<3);
	A10 = A10 - x13;
	A11 = A11 + (x13<<6);
	A14 = A14 + (x13<<7);

	tmp1 = -x14 + (x14<<5);
	A01 = (A01 - tmp1);
	A03 = A03 - (x14<<6);
	tmp1 = x14 + (x14<<5);
	A06 = (A06 + (tmp1<<2));
	A09 = A09 - (x14<<3);
	A14 = A14 - (x14<<6);

	A02 = A02 + (x15<<5);
	A06 = A06 + (x15<<6);
	A13 = A13 - (x15<<3);

	tmp00 = x02 + (x02<<1);
	tmp0 = (-tmp00 + (x02<<4));
	tmp10 = x07 + (x07<<1);
	tmp1 = (-tmp10 + (tmp10<<3));
	x16 = (tmp0 - tmp1);
	A02 = A02 + x16;
	A04 = A04 - (x16<<2);
	A13 = A13 - (x16<<1);

	tmp0 = x05 + (x05<<1);
	tmp1 = x15 + (x15<<2);
	x17 = (tmp0 - (tmp1<<1));
	A01 = A01 + x17;
	A04 = A04 - (x17<<2);
	tmp1 = -x17 + (x17<<3);
	A07 = (A07 - tmp1);
	A09 = A09 + x17;
	A12 = A12 + (x17<<4);
	A14 = A14 - x17;

	tmp0 = x09 + (x09<<2);
	tmp1 = x14 + (x14<<1);
	x18 = (tmp0 - tmp1);
	A04 = A04 - (x18<<3);
	A05 = A05 - (x18<<3);
	A06 = A06 + (x18<<4);
	A11 = A11 - (x18<<3);
	A13 = A13 - x18;

	tmp0 = -x01 + (x01<<4);
	tmp10 = x08 + (x08<<1);
	tmp1 = (tmp10 + (x08<<3));
	x19 = (tmp0 + tmp1);
	A00 = A00 + (x19<<3);
	A12 = A12 - x19;

	tmp1 = x13 + (x13<<2);
	x20 = ((x04<<1) - tmp1);
	A00 = A00 + (x20<<1);
	A03 = A03 + (x20<<4);
	A09 = A09 - (x20<<1);
	A14 = A14 + (x20<<2);

	tmp1 = x12 + (x12<<1);
	x21 = (x03 - tmp1);
	A07 = A07 - (x21<<5);
	A13 = A13 - x21;
	tmp1 = -x21 + (x21<<4);
	A15 = (A15 - (tmp1<<1));

	tmp0 = x06 + (x06<<2);
	tmp1 = -x10 + (x10<<3);
	x22 = (tmp0 - tmp1);
	A01 = A01 - (x22<<1);
	A04 = A04 + (x22<<4);
	A15 = A15 - (x22<<1);

	tmp0 = x00 + (x00<<2);
	x23 = ((tmp0<<1) + x08);
	A09 = A09 - x23;
	A13 = A13 - x23;

	tmp0 = x11 + (x11<<1);
	x24 = ((tmp0<<1) - x21);
	A00 = A00 + (x24<<3);
	A07 = A07 - x24;
	A09 = A09 - (x24<<3);

	x25 = x09 - (x10<<2);
	A02 = A02 - (x25<<1);
	A04 = A04 - (x25<<2);
	A09 = A09 - x25;

	x26 = (x12<<3) + x22;
	A01 = A01 - (x26<<2);
	A10 = A10 + (x26<<3);

	x27 = (x00<<3) - x19;
	A09 = A09 + (x27<<3);
	A10 = A10 - (x27<<1);

	x28 = x11 - x14;
	A00 = A00 - (x28<<3);
	A04 = A04 - (x28<<6);
	A12 = A12 + (x28<<5);
	tmp1 = x28 + (x28<<6);
	A15 = (A15 - tmp1);

	x29 = x04 + (x05<<2);
	A01 = A01 - (x29<<1);
	tmp1 = x29 + (x29<<4);
	A02 = (A02 - tmp1);
	A10 = A10 + (x29<<3);

	tmp1 = -x23 + (x23<<3);
	x30 = ((x03<<6) - tmp1);
	A03 = A03 - x30;
	A08 = A08 + x30;

	x31 = x02 + (x03<<1);
	A00 = A00 + (x31<<4);
	A05 = A05 + (x31<<1);

	x32 = x18 - (x20<<1);
	A02 = A02 + x32;
	A07 = A07 + x32;

	x33 = x06 + x09;
	A11 = A11 - (x33<<5);

	tmp0 = -x04 + (x04<<5);
	x34 = (tmp0 - x19);
	A04 = A04 - (x34<<1);
	A07 = A07 + (x34<<2);

	x35 = x03 + x17;
	A02 = A02 + x35;

	x36 = (x05<<3) + x17;
	A08 = A08 - (x36<<3);

	x37 = x15 - x16;
	A15 = A15 - (x37<<1);

	x38 = x01 + x12;
	A09 = A09 + (x38<<1);
	A10 = A10 + (x38<<3);
	A11 = A11 - (x38<<6);

	x39 = (x08<<2) - x36;
	A05 = A05 - (x39<<3);
	A14 = A14 + (x39<<3);

	x40 = x07 - (x08<<2);
	A12 = A12 - (x40<<2);

	x41 = x04 + x35;
	A06 = A06 + x41;
	A13 = A13 + (x41<<3);

	tmp0 = -x11 + (x11<<3);
	x42 = (tmp0 - (x31<<1));
	A09 = A09 - (x42<<2);
	A10 = A10 + (x42<<1);
	A13 = A13 + (x42<<3);

	x43 = x07 - x22;
	A13 = A13 + x43;

	x44 = (x01<<3) - x20;
	A07 = A07 + x44;
	A10 = A10 - (x44<<4);

	x45 = x10 - x13;
	A03 = A03 - x45;
	A06 = A06 + x45;

	x46 = x01 - (x05<<1);
	A03 = A03 + (x46<<5);
	A09 = A09 + (x46<<5);

	x47 = x09 - x43;
	A08 = A08 + x47;
	A10 = A10 + (x47<<2);
	A11 = A11 - (x47<<1);

	x48 = x10 + x33;
	A00 = A00 + (x48<<6);
	A06 = A06 + (x48<<1);
	A10 = A10 - x48;

	x49 = (x02<<6) + x30;
	A06 = A06 - x49;

	x50 = x00 - (x26<<2);
	A12 = A12 - (x50<<1);

	x51 = (x03<<1) - x25;
	A02 = A02 + (x51<<3);
	A05 = A05 + x51;
	A13 = A13 - (x51<<5);

	tmp1 = -x24 + (x24<<4);
	x52 = ((x00<<1) - tmp1);
	A01 = A01 + x52;
	A05 = A05 - x52;

	x53 = (x11<<1) + x22;
	A04 = A04 - x53;
	A09 = A09 - x53;
	A14 = A14 + (x53<<2);

	x54 = (x05<<3) - x21;
	A02 = A02 - (x54<<1);

	x55 = (x00<<3) + x20;
	A01 = A01 + (x55<<4);
	A03 = A03 + (x55<<1);
	A08 = A08 + (x55<<4);

	x56 = (x07<<4) + x19;
	A03 = A03 + x56;

	x57 = x14 + x16;
	A10 = A10 + (x57<<1);

	tmp0 = x15 + (x15<<4);
	x58 = ((tmp0<<1) + x57);
	A10 = A10 + (x58<<1);

	x59 = x07 + (x15<<3);
	A00 = A00 + x59;

	x60 = (x11<<1) - x12;
	A03 = A03 - x60;
	A11 = A11 + (x60<<5);
	A12 = A12 - x60;

	tmp1 = x11 + (x11<<1);
	x61 = ((x01<<3) + tmp1);
	tmp1 = -x61 + (x61<<3);
	A08 = (A08 + tmp1);

	x62 = (x04<<1) - x09;
	A03 = A03 - (x62<<6);
	A10 = A10 - (x62<<6);
	A14 = A14 + (x62<<5);

	x63 = (x02<<5) + x05;
	A05 = A05 - (x63<<1);

	x64 = x03 + (x03<<1);
	tmp1 = -x64 + (x64<<4);
	A04 = (A04 - (tmp1<<1));
	tmp1 = -x64 + (x64<<5);
	A14 = (A14 - tmp1);

	x65 = (x13<<2) - x63;
	A11 = A11 - (x65<<1);
	A12 = A12 - (x65<<1);

	x66 = x27 - x61;

	x67 = (x40<<5) - x66;
	A01 = A01 + x67;
	A11 = A11 - x67;

	x68 = (x03<<3) - x59;
	A07 = A07 + (x68<<4);
	A09 = A09 + (x68<<3);

	x69 = (x08<<6) - x58;
	A03 = A03 + x69;
	A05 = A05 - x69;

	x70 = (x21<<3) + x56;

	x71 = (x44<<2) - x70;
	A02 = A02 + (x71<<2);
	A14 = A14 - (x71<<1);

	x72 = (x06<<2) + x54;

	x73 = (x23<<3) + x72;
	A00 = A00 + (x73<<1);
	A04 = A04 + x73;

	x74 = (x03<<4) + x50;

	x75 = (x13<<1) - x74;
	A06 = A06 - (x75<<1);
	A08 = A08 - x75;

	x76 = (x18<<1) - x49;
	A00 = A00 - x76;
	A07 = A07 + x76;

	x77 = (x13<<3) - x46;
	A04 = A04 + (x77<<3);
	A15 = A15 - x77;

	x78 = (x14<<1) + x45;
	A07 = A07 - (x78<<5);
	A13 = A13 + (x78<<5);

	x79 = (x03<<6) - x41;
	A10 = A10 + x79;
	A12 = A12 - x79;

	x80 = (x10<<2) - x40;
	A00 = A00 - (x80<<2);
	A15 = A15 + (x80<<4);

	x81 = x02 - x39;
	A11 = A11 + (x81<<3);
	A15 = A15 - (x81<<2);

	x82 = (x02<<2) - x38;
	A08 = A08 + x82;
	A14 = A14 - x82;

	x83 = x10 + (x37<<2);
	A01 = A01 - x83;
	A08 = A08 + x83;

	x84 = x13 + x37;
	A09 = A09 + x84;
	A14 = A14 - x84;

	x85 = (x29<<3) + x34;
	A00 = A00 + (x85<<1);
	A06 = A06 + (x85<<1);

	x86 = (x04<<4) + x33;
	A07 = A07 - (x86<<1);
	A11 = A11 - (x86<<2);

	x87 = x04 - x32;
	A09 = A09 - (x87<<3);
	A15 = A15 + (x87<<3);

	x88 = (x31<<3) + x32;
	A01 = A01 + (x88<<1);
	A05 = A05 - (x88<<2);

	x89 = x01 - (x28<<2);

	x90 = x14 + (x89<<1);

	x91 = (x16<<1) - x90;
	A12 = A12 + x91;
	A14 = A14 + (x91<<1);

	x92 = (x12<<2) - x27;
	A13 = A13 - (x92<<2);
	A15 = A15 - x92;

	x93 = (x25<<3) - x27;
	A01 = A01 + (x93<<2);
	A12 = A12 - (x93<<2);

	x94 = (x06<<1) - x26;
	A03 = A03 + (x94<<3);
	A05 = A05 - x94;

	x95 = x16 + (x24<<2);
	A06 = A06 - (x95<<1);
	A07 = A07 - x95;

	x96 = (x14<<4) - x23;
	A02 = A02 + (x96<<2);
	A05 = A05 - (x96<<3);

	x97 = (x06<<4) - x22;
	A07 = A07 - (x97<<3);
	A09 = A09 + (x97<<3);

	x98 = x15 + (x21<<1);
	A08 = A08 + x98;
	A11 = A11 - x98;

	x99 = (x18<<1) + x20;
	A08 = A08 - x99;
	A12 = A12 + x99;

	x100 = x15 + x18;
	A03 = A03 + (x100<<2);
	A08 = A08 - (x100<<4);

	x101 = x06 - (x15<<1);
	A12 = A12 - (x101<<7);
	A15 = A15 + (x101<<6);

	x102 = (x07<<1) + x13;
	A00 = A00 + (x102<<5);
	A13 = A13 + (x102<<1);

	tmp0 = x06 + (x06<<2);
	x103 = (tmp0 - (x11<<2));
	tmp1 = x103 + (x103<<3);
	A02 = (A02 - (tmp1<<1));

	x104 = (x06<<1) + x10;
	A05 = A05 + (x104<<5);
	A14 = A14 + (x104<<5);
	//~code end
	AL[ 0] = A00; AL[ 1] = A01; AL[ 2] = A02; AL[ 3] = A03; 
	AL[ 4] = A04; AL[ 5] = A05; AL[ 6] = A06; AL[ 7] = A07; 
	AL[ 8] = A08; AL[ 9] = A09; AL[10] = A10; AL[11] = A11; 
	AL[12] = A12; AL[13] = A13; AL[14] = A14; AL[15] = A15; 

	//verify
	const int dim = 16;
	int bstOdd16x16[256] = {
 90, 90, 88, 86, 82, 78, 72, 69, 59, 54, 48, 40, 30, 22, 14,  8,
 90, 83, 68, 47, 22, -5,-30,-52,-73,-86,-91,-87,-77,-60,-37,-14,
 88, 68, 29,-13,-53,-81,-90,-77,-48, -5, 40, 72, 90, 86, 61, 22,
 86, 47,-13,-64,-91,-73,-23, 37, 82, 88, 55, -2,-63,-89,-77,-30,
 82, 22,-53,-91,-62, 12, 79, 86, 30,-44,-89,-66,  3, 72, 88, 40,
 78, -5,-81,-73, 12, 86, 67,-21,-88,-61, 29, 90, 53,-40,-91,-46,
 72,-30,-90,-23, 79, 67,-38,-90,-15, 82, 59,-47,-88, -5, 84, 54,
 69,-52,-77, 37, 86,-21,-90,  7, 91, 13,-88,-30, 82, 47,-73,-58,
 59,-73,-48, 82, 30,-88,-15, 91, -7,-89, 22, 85,-39,-77, 54, 69,
 54,-86, -5, 88,-44,-61, 82, 13,-89, 39, 67,-78,-22, 91,-32,-73,
 48,-91, 40, 55,-89, 29, 59,-88, 22, 67,-85, 14, 72,-81,  4, 78,
 40,-87, 72, -2,-66, 90,-47,-30, 85,-78, 14, 61,-90, 56, 24,-81,
 30,-77, 90,-63,  3, 53,-88, 82,-39,-22, 72,-90, 65,-13,-47, 86,
 22,-60, 86,-89, 72,-40, -5, 47,-77, 91,-81, 56,-13,-30, 67,-88,
 14,-37, 61,-77, 88,-91, 84,-73, 54,-32,  4, 24,-47, 67,-82, 89,
  8,-14, 22,-30, 40,-46, 54,-58, 69,-73, 78,-81, 86,-88, 89,-90};
	for(int ii=0; ii<dim*dim; ii++)
	{
		if(bstOdd16x16[ii] != AL[ii/dim][ii%dim])
			printf("idx %3d  value %10d %10d\n", ii, bstOdd16x16[ii], AL[ii/dim][ii%dim]);

	}
}
void vrfy_mtrx_bstOdd8x8()
{
	VECINT tmp, tmp0, tmp00, tmp000, tmp0000, tmp0001, tmp001, tmp0010, tmp0011, tmp01, tmp010, tmp0100, tmp0101, 
				 tmp011, tmp0110, tmp0111, tmp1, tmp10, tmp100,
				 tmp1000, tmp1001, tmp101, tmp1010, tmp1011, tmp11, tmp110, tmp1100, tmp1101, tmp111, tmp1110, tmp1111;
	VECINT A00, A01, A02, A03, A04, A05, A06, A07, A08, A09, A10, A11, A12, A13, A14, A15, AL[16];
	VECINT x00, x01, x02, x03, x04, x05, x06, x07, x08, x09, x10, x11, x12, x13, x14, x15;
	VECINT x16, x17, x18, x19, x20, x21, x22, x23, x24, x25, x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37, x38, x39, x40, x41, x42, x43, x44, x45,
				x46, x47, x48, x49, x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61, x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73, x74, x75,
				x76, x77, x78, x79, x80, x81, x82, x83, x84, x85, x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97, x98, x99, x100, x101, x102, x103, x104,
				x105, x106, x107, x108, x109, x110, x111, x112, x113, x114, x115, x116, x117, x118, x119, x120, x121, x122, x123, x124, x125, x126, x127;
	x00[ 0] = 1;	x01[ 1] = 1;	x02[ 2] = 1;	x03[ 3] = 1;
	x04[ 4] = 1;	x05[ 5] = 1;	x06[ 6] = 1;	x07[ 7] = 1;
	x08[ 8] = 1;	x09[ 9] = 1;	x10[10] = 1;	x11[11] = 1;
	x12[12] = 1;	x13[13] = 1;	x14[14] = 1;	x15[15] = 1;

	//code start
	A00 = -((x00<<2));
	tmp0 = x00 + (x00<<2);
	A01 = (tmp0 + (tmp0<<4));
	A04 = (x00<<1);
	A05 = -((x00<<1));

	A00 = A00 + (x01<<1);
	A01 = A01 + (x01<<6);
	A03 = -((x01<<5));

	tmp1 = -x02 + (x02<<3);
	A04 = (A04 - tmp1);

	A02 = -((x03<<5));

	A01 = A01 - (x04<<4);
	A03 = A03 + (x04<<7);
	tmp1 = x04 + (x04<<1);
	A05 = (A05 - (tmp1<<5));

	A02 = A02 + (x05<<5);
	A03 = A03 + (x05<<3);
	A06 = x05 + (x05<<3);

	A00 = A00 + (x06<<3);
	A04 = A04 + (x06<<5);
	tmp1 = x06 + (x06<<3);
	A05 = (A05 + tmp1);
	A06 = A06 - (x06<<5);

	A03 = A03 - (x07<<4);
	A06 = A06 + (x07<<7);
	A07 = -((x07<<7));

	tmp0 = x06 + (x06<<2);
	x08 = (tmp0 + (x07<<1));
	A02 = A02 + (x08<<1);
	tmp1 = x08 + (x08<<2);
	A06 = (A06 - tmp1);

	tmp1 = x05 + (x05<<2);
	x09 = ((x03<<1) + tmp1);
	A01 = A01 - (x09<<1);
	tmp1 = -x09 + (x09<<3);
	A05 = (A05 + (tmp1<<1));

	tmp0 = x02 + (x02<<2);
	x10 = (tmp0 + (x04<<1));

	tmp1 = x01 + (x01<<2);
	x11 = ((x00<<1) - tmp1);
	A00 = A00 - x11;
	A05 = A05 + (x11<<1);

	x12 = x04 + (x10<<1);
	A00 = A00 + (x12<<3);
	A06 = A06 + (x12<<3);
	A07 = A07 + x12;

	x13 = x07 + (x08<<1);

	x14 = x00 + (x11<<1);

	x15 = (x03<<2) - x11;

	x16 = (x07<<4) - x10;
	A04 = A04 + (x16<<2);
	tmp1 = x16 + (x16<<2);
	A05 = (A05 - tmp1);
	A06 = A06 - (x16<<1);

	x17 = (x09<<4) - x13;
	A04 = A04 - x17;

	x18 = (x00<<4) + x09;
	A02 = A02 + x18;

	x19 = (x04<<2) + x08;
	A01 = A01 - (x19<<4);

	x20 = x06 - (x19<<2);
	A00 = A00 - x20;
	A07 = A07 - (x20<<2);

	x21 = x07 - (x18<<1);

	x22 = (x10<<3) + x21;
	A02 = A02 - (x22<<1);
	A03 = A03 - (x22<<1);

	x23 = (x03<<1) + x17;
	A01 = A01 - x23;
	A07 = A07 - x23;

	x24 = (x01<<1) + x15;

	x25 = (x02<<3) - x24;
	A01 = A01 + x25;
	A07 = A07 + (x25<<2);

	x26 = x04 + (x15<<3);
	A00 = A00 + (x26<<1);
	A06 = A06 - (x26<<1);

	x27 = (x02<<2) + x14;
	A03 = A03 + x27;
	A05 = A05 + (x27<<3);

	x28 = (x03<<4) + x14;
	A04 = A04 + (x28<<3);
	A06 = A06 - x28;

	x29 = x12 + (x13<<3);
	A02 = A02 + x29;
	A03 = A03 - x29;

	x30 = x03 + (x09<<1);
	A00 = A00 + x30;
	A04 = A04 - x30;

	x31 = (x00<<2) + x05;
	A00 = A00 + (x31<<5);
	A04 = A04 + (x31<<2);

	x32 = x01 - (x03<<3);
	A02 = A02 + (x32<<3);
	A07 = A07 + x32;
	//~code end
	AL[ 0] = A00; AL[ 1] = A01; AL[ 2] = A02; AL[ 3] = A03; 
	AL[ 4] = A04; AL[ 5] = A05; AL[ 6] = A06; AL[ 7] = A07; 
	AL[ 8] = A08; AL[ 9] = A09; AL[10] = A10; AL[11] = A11; 
	AL[12] = A12; AL[13] = A13; AL[14] = A14; AL[15] = A15; 

	//verify
	const int dim = 8;
	int bstOdd8x8[64] = {
 90, 87, 80, 69, 58, 42, 27,  8,
 87, 57,  8,-42,-80,-90,-70,-27,
 80,  8,-70,-86,-27, 57, 90, 42,
 69,-42,-86,  8, 91, 28,-80,-58,
 58,-80,-27, 91, -8,-86, 42, 69,
 42,-90, 57, 28,-86, 70,  9,-80,
 27,-70, 90,-80, 42,  9,-57, 86,
  8,-27, 42,-58, 69,-80, 86,-91};
	
	for(int ii=0; ii<dim*dim; ii++)
	{
		if(bstOdd8x8[ii] != AL[ii/dim][ii%dim])
			printf("idx %3d  value %10d %10d\n", ii, bstOdd8x8[ii], AL[ii/dim][ii%dim]);

	}
}
void vrfy_mtrx_bstOdd4x4()
{
	VECINT tmp, tmp0, tmp00, tmp000, tmp0000, tmp0001, tmp001, tmp0010, tmp0011, tmp01, tmp010, tmp0100, tmp0101, 
				 tmp011, tmp0110, tmp0111, tmp1, tmp10, tmp100,
				 tmp1000, tmp1001, tmp101, tmp1010, tmp1011, tmp11, tmp110, tmp1100, tmp1101, tmp111, tmp1110, tmp1111;
	VECINT A00, A01, A02, A03, A04, A05, A06, A07, A08, A09, A10, A11, A12, A13, A14, A15, AL[16];
	VECINT x00, x01, x02, x03, x04, x05, x06, x07, x08, x09, x10, x11, x12, x13, x14, x15;
	VECINT x16, x17, x18, x19, x20, x21, x22, x23, x24, x25, x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37, x38, x39, x40, x41, x42, x43, x44, x45,
				x46, x47, x48, x49, x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61, x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73, x74, x75,
				x76, x77, x78, x79, x80, x81, x82, x83, x84, x85, x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97, x98, x99, x100, x101, x102, x103, x104,
				x105, x106, x107, x108, x109, x110, x111, x112, x113, x114, x115, x116, x117, x118, x119, x120, x121, x122, x123, x124, x125, x126, x127;
	x00[ 0] = 1;	x01[ 1] = 1;	x02[ 2] = 1;	x03[ 3] = 1;
	x04[ 4] = 1;	x05[ 5] = 1;	x06[ 6] = 1;	x07[ 7] = 1;
	x08[ 8] = 1;	x09[ 9] = 1;	x10[10] = 1;	x11[11] = 1;
	x12[12] = 1;	x13[13] = 1;	x14[14] = 1;	x15[15] = 1;

	//code start
	A01 = (x00<<3);

	A00 = (x01<<1) + (x01<<6);
	A01 = A01 + x01;
	A02 = -((x01<<7));

	A01 = A01 - (x02<<7);
	A02 = A02 - x02;
	A03 = (x02<<1) + (x02<<6);

	A02 = A02 + (x03<<3);

	tmp0 = x01 + (x01<<2);
	tmp1 = x03 + (x03<<4);
	x04 = ((tmp0<<1) + tmp1);
	A01 = A01 - (x04<<1);
	tmp1 = x04 + (x04<<2);
	A03 = (A03 - tmp1);

	tmp0 = x00 + (x00<<4);
	tmp1 = x02 + (x02<<2);
	x05 = (tmp0 + (tmp1<<1));
	tmp1 = x05 + (x05<<2);
	A00 = (A00 + tmp1);
	A02 = A02 + (x05<<1);

	x06 = (x03<<2) - x05;
	A01 = A01 - (x06<<2);
	A03 = A03 - x06;

	x07 = (x00<<2) + x04;
	A00 = A00 + x07;
	A02 = A02 + (x07<<2);
	//~code end
	AL[ 0] = A00; AL[ 1] = A01; AL[ 2] = A02; AL[ 3] = A03; 
	AL[ 4] = A04; AL[ 5] = A05; AL[ 6] = A06; AL[ 7] = A07; 
	AL[ 8] = A08; AL[ 9] = A09; AL[10] = A10; AL[11] = A11; 
	AL[12] = A12; AL[13] = A13; AL[14] = A14; AL[15] = A15; 

	//verify
	const int dim = 4;
	int bstOdd4x4[16] = {
89, 76, 50, 17,
76,-19,-88,-50,
50,-88, 19, 76,
17,-50, 76,-89};
	for(int ii=0; ii<dim*dim; ii++)
	{
		if(bstOdd4x4[ii] != AL[ii/dim][ii%dim])
			printf("idx %3d  value %10d %10d\n", ii, bstOdd4x4[ii], AL[ii/dim][ii%dim]);

	}
}
void vrfy_mtrx_HMOdd16x16()
{
	VECINT tmp, tmp0, tmp00, tmp000, tmp0000, tmp0001, tmp001, tmp0010, tmp0011, tmp01, tmp010, tmp0100, tmp0101, 
				 tmp011, tmp0110, tmp0111, tmp1, tmp10, tmp100,
				 tmp1000, tmp1001, tmp101, tmp1010, tmp1011, tmp11, tmp110, tmp1100, tmp1101, tmp111, tmp1110, tmp1111;
	VECINT A00, A01, A02, A03, A04, A05, A06, A07, A08, A09, A10, A11, A12, A13, A14, A15, AL[16];
	VECINT x00, x01, x02, x03, x04, x05, x06, x07, x08, x09, x10, x11, x12, x13, x14, x15;
	VECINT x16, x17, x18, x19, x20, x21, x22, x23, x24, x25, x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37, x38, x39, x40, x41, x42, x43, x44, x45,
				x46, x47, x48, x49, x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61, x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73, x74, x75,
				x76, x77, x78, x79, x80, x81, x82, x83, x84, x85, x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97, x98, x99, x100, x101, x102, x103, x104,
				x105, x106, x107, x108, x109, x110, x111, x112, x113, x114, x115, x116, x117, x118, x119, x120, x121, x122, x123, x124, x125, x126, x127;
	x00[ 0] = 1;	x01[ 1] = 1;	x02[ 2] = 1;	x03[ 3] = 1;
	x04[ 4] = 1;	x05[ 5] = 1;	x06[ 6] = 1;	x07[ 7] = 1;
	x08[ 8] = 1;	x09[ 9] = 1;	x10[10] = 1;	x11[11] = 1;
	x12[12] = 1;	x13[13] = 1;	x14[14] = 1;	x15[15] = 1;

	//code start
	A02 = (x00<<7);
	A06 = (x00<<6);
	A07 = -((x00<<3));
	A10 = x00;
	A13 = (x00<<5);
	A14 = -((x00<<5));

	A02 = A02 + (x01<<1);
	A08 = -((x01<<6));
	A09 = -(x01);
	A11 = -((x01<<6));

	A00 = (x02<<7);
	A03 = (x02<<5);
	A04 = -((x02<<7));
	A11 = A11 + (x02<<6);
	A14 = A14 + x02;

	A00 = A00 + x03;
	A02 = A02 - (x03<<3);
	tmp1 = -x03 + (x03<<6);
	A03 = (A03 - tmp1);
	A05 = -(x03);
	A09 = A09 + (x03<<7);
	A12 = -(x03);

	A00 = A00 + (x04<<1);
	A01 = (x04<<5);
	A04 = A04 - (x04<<4);
	A05 = A05 - (x04<<5);
	A08 = A08 + (x04<<2);
	A12 = A12 + (x04<<2);
	A13 = A13 + (x04<<6);
	A14 = A14 + (x04<<7);

	A07 = A07 + (x05<<5);
	A09 = A09 - x05;
	tmp1 = x05 + (x05<<6);
	A10 = (A10 - tmp1);

	A01 = A01 - (x06<<2);
	A02 = A02 - (x06<<3);
	tmp1 = -x06 + (x06<<3);
	A07 = (A07 - (tmp1<<3));
	A08 = A08 + (x06<<5);
	A10 = A10 + x06;

	A00 = A00 + x07;
	A02 = A02 - (x07<<6);
	A04 = A04 + x07;
	A07 = A07 + (x07<<2);
	A09 = A09 + (x07<<4);
	A12 = A12 - (x07<<4);
	A14 = A14 - (x07<<6);

	A01 = A01 - x08;
	A03 = A03 - (x08<<4);
	A08 = A08 - (x08<<2);
	A11 = A11 + x08;
	A13 = A13 - (x08<<6);
	A15 = x08 + (x08<<6);

	A03 = A03 + (x09<<7);
	A05 = A05 - x09;
	A06 = A06 + (x09<<1);
	A11 = A11 - (x09<<1);
	A14 = A14 - (x09<<2);

	A05 = A05 - (x10<<6);
	A08 = A08 - (x10<<5);
	A10 = A10 - x10;
	A11 = A11 + (x10<<4);
	A12 = A12 + (x10<<6);
	A13 = A13 + (x10<<4);
	A15 = A15 + (x10<<6);

	A00 = A00 - (x11<<5);
	A07 = A07 - (x11<<2);
	A09 = A09 + (x11<<1);
	A10 = A10 - (x11<<5);
	A15 = A15 - (x11<<1);

	A00 = A00 - (x12<<6);
	A10 = A10 + (x12<<6);
	A12 = A12 - x12;
	A13 = A13 - (x12<<4);

	A07 = A07 + x13;
	A08 = A08 - (x13<<5);
	tmp1 = x13 + (x13<<7);
	A11 = (A11 + tmp1);
	A15 = A15 - (x13<<7);

	A03 = A03 - (x14<<1);
	A06 = A06 + x14;
	A07 = A07 - x14;
	A09 = A09 + (x14<<6);

	tmp1 = x15 + (x15<<3);
	A03 = (A03 - (tmp1<<2));
	A06 = A06 + (x15<<7);
	A09 = A09 - (x15<<6);
	A13 = A13 - (x15<<7);

	tmp0 = x07 + (x07<<1);
	tmp1 = x15 + (x15<<2);
	x16 = ((tmp0<<1) + tmp1);
	A02 = A02 + (x16<<1);
	A08 = A08 - x16;
	A15 = A15 - (x16<<3);

	tmp0 = x06 + (x06<<2);
	tmp1 = x14 + (x14<<1);
	x17 = (tmp0 - (tmp1<<1));
	A02 = A02 - (x17<<3);
	A06 = A06 + (x17<<1);
	A14 = A14 + (x17<<4);
	A15 = A15 + x17;

	tmp0 = x05 + (x05<<1);
	tmp1 = x13 + (x13<<2);
	x18 = ((tmp0<<1) - tmp1);
	A02 = A02 - (x18<<4);
	A10 = A10 + (x18<<4);
	A11 = A11 + (x18<<4);
	A12 = A12 + x18;
	A14 = A14 + x18;

	tmp0 = x04 + (x04<<2);
	tmp1 = x12 + (x12<<1);
	x19 = (tmp0 + (tmp1<<1));
	tmp1 = x19 + (x19<<2);
	A03 = (A03 - (tmp1<<1));
	A11 = A11 + x19;

	tmp0 = x03 + (x03<<1);
	tmp1 = x11 + (x11<<2);
	x20 = ((tmp0<<1) + tmp1);
	A12 = A12 - (x20<<1);

	tmp0 = x02 + (x02<<2);
	tmp1 = x10 + (x10<<1);
	x21 = (tmp0 - (tmp1<<1));
	A03 = A03 - x21;
	A06 = A06 - (x21<<3);
	A07 = A07 + (x21<<2);
	A10 = A10 - (x21<<1);
	tmp1 = x21 + (x21<<4);
	A13 = (A13 + tmp1);

	tmp0 = x01 + (x01<<1);
	tmp1 = x09 + (x09<<2);
	x22 = ((tmp0<<1) - tmp1);
	tmp1 = x22 + (x22<<4);
	A01 = (A01 + tmp1);
	A07 = A07 - (x22<<3);
	A09 = A09 - (x22<<4);
	A13 = A13 - (x22<<3);

	tmp0 = x00 + (x00<<2);
	tmp1 = x08 + (x08<<1);
	x23 = (tmp0 + (tmp1<<1));
	A05 = A05 - (x23<<2);
	A07 = A07 - x23;
	A09 = A09 - (x23<<4);
	A11 = A11 + (x23<<4);
	A14 = A14 + (x23<<3);

	x24 = (x07<<1) - x14;
	A11 = A11 + (x24<<5);
	A14 = A14 - (x24<<2);

	x25 = x01 + (x08<<1);
	A04 = A04 - (x25<<5);
	A15 = A15 + x25;

	x26 = (x02<<2) - x23;
	A07 = A07 - (x26<<4);
	A10 = A10 - (x26<<3);

	tmp0 = x04 + (x04<<2);
	x27 = (tmp0 - x22);
	A03 = A03 - (x27<<3);
	A04 = A04 - x27;
	A13 = A13 + (x27<<1);

	tmp0 = x00 + (x00<<2);
	x28 = (tmp0 - x21);
	A00 = A00 + (x28<<3);
	A01 = A01 + (x28<<1);
	A05 = A05 + (x28<<4);
	A06 = A06 + (x28<<1);

	x29 = (x06<<2) - x20;
	A00 = A00 + (x29<<1);
	A13 = A13 - x29;

	x30 = (x09<<2) + x19;
	A05 = A05 + x30;
	A11 = A11 - (x30<<4);

	x31 = (x03<<2) + x18;
	tmp1 = x31 + (x31<<2);
	A09 = (A09 - (tmp1<<1));
	A14 = A14 - (x31<<4);

	tmp0 = x11 + (x11<<2);
	x32 = (tmp0 - x17);
	A02 = A02 + (x32<<1);
	A09 = A09 - (x32<<4);
	A12 = A12 - (x32<<3);

	tmp0 = x05 + (x05<<2);
	x33 = (tmp0 - x16);
	A02 = A02 + (x33<<2);
	A03 = A03 - x33;
	A04 = A04 + x33;
	A13 = A13 - (x33<<3);

	x34 = x10 + x15;
	A06 = A06 + x34;
	A07 = A07 - (x34<<6);

	x35 = (x10<<1) + x12;
	A00 = A00 - x35;
	A09 = A09 + (x35<<5);
	A13 = A13 + (x35<<1);

	x36 = (x03<<1) - x17;
	A05 = A05 - (x36<<5);
	A06 = A06 + (x36<<4);
	A14 = A14 - x36;

	x37 = (x05<<1) + x13;
	A00 = A00 + (x37<<5);
	A06 = A06 - (x37<<2);

	x38 = x12 - (x27<<1);
	A04 = A04 + (x38<<2);
	A10 = A10 + (x38<<3);

	x39 = (x20<<3) + x23;
	A10 = A10 + x39;
	A12 = A12 - x39;

	x40 = (x15<<2) - x22;
	A00 = A00 + x40;
	A09 = A09 - (x40<<1);

	tmp0 = -x13 + (x13<<3);
	x41 = (tmp0 + x21);

	x42 = (x00<<1) - x16;
	A04 = A04 + x42;
	tmp1 = x42 + (x42<<3);
	A05 = (A05 + tmp1);
	A15 = A15 + (x42<<1);

	x43 = x13 - (x14<<1);
	A04 = A04 - (x43<<5);
	A10 = A10 - (x43<<1);

	x44 = x02 + (x11<<4);
	A01 = A01 - (x44<<3);
	A07 = A07 - (x44<<1);

	x45 = x08 + x09;
	A00 = A00 + x45;
	A04 = A04 - x45;

	x46 = x06 - x07;
	A03 = A03 - (x46<<5);
	A10 = A10 + (x46<<6);
	A11 = A11 - x46;
	A15 = A15 + x46;

	x47 = (x01<<4) - x35;
	A15 = A15 - x47;

	tmp1 = x32 + (x32<<3);
	x48 = (x31 - tmp1);
	A05 = A05 - (x48<<1);
	A11 = A11 - x48;

	x49 = x01 - x28;
	A01 = A01 - (x49<<4);

	x50 = x11 - x25;
	A13 = A13 + x50;

	x51 = x04 + x24;
	A02 = A02 - x51;
	A09 = A09 - x51;
	A13 = A13 - x51;

	x52 = (x09<<3) + x22;
	A00 = A00 + (x52<<4);
	A10 = A10 - x52;
	A11 = A11 - (x52<<2);

	x53 = (x04<<1) + x20;
	A15 = A15 - (x53<<4);

	x54 = x05 + (x19<<3);
	A15 = A15 + (x54<<1);

	x55 = (x06<<1) - x19;
	A02 = A02 - (x55<<4);
	tmp1 = x55 + (x55<<4);
	A07 = (A07 - tmp1);
	A09 = A09 + x55;

	x56 = x01 - (x18<<2);
	A15 = A15 + (x56<<1);

	x57 = (x14<<3) + x18;
	A00 = A00 + (x57<<1);
	tmp1 = x57 + (x57<<3);
	A07 = (A07 - tmp1);

	x58 = (x06<<3) - x17;
	A04 = A04 + (x58<<2);

	x59 = (x00<<5) + x10;
	A09 = A09 + (x59<<2);

	x60 = x03 - x09;
	A07 = A07 + (x60<<5);
	tmp1 = x60 + (x60<<6);
	A15 = (A15 + tmp1);

	x61 = x02 + (x02<<2);
	A06 = A06 - (x61<<3);
	tmp1 = x61 + (x61<<3);
	A12 = (A12 + (tmp1<<1));

	x62 = x09 + (x09<<2);
	A13 = A13 + (x62<<3);

	x63 = x12 + (x12<<2);
	A06 = A06 - (x63<<4);
	A07 = A07 - (x63<<2);

	x64 = x15 + (x15<<2);
	tmp1 = x64 + (x64<<3);
	A14 = (A14 + (tmp1<<1));
	A15 = A15 - (x64<<3);

	x65 = x17 + (x62<<1);

	x66 = x49 + x65;
	tmp1 = x66 + (x66<<3);
	A08 = (A08 - tmp1);

	x67 = (x16<<4) + x59;
	A11 = A11 - x67;
	A12 = A12 + x67;

	x68 = (x02<<1) + x58;
	A05 = A05 - x68;
	A15 = A15 + (x68<<4);

	x69 = (x45<<4) + x56;
	A05 = A05 - (x69<<2);
	A12 = A12 - (x69<<1);

	x70 = (x07<<5) + x54;
	A00 = A00 + (x70<<1);
	A05 = A05 + x70;

	x71 = x00 + x53;
	A06 = A06 - x71;
	A08 = A08 + (x71<<4);

	x72 = (x01<<6) - x50;
	A02 = A02 + x72;
	A06 = A06 + x72;

	x73 = x22 + (x47<<1);
	A12 = A12 - (x73<<1);
	A14 = A14 - x73;

	x74 = (x26<<1) + x44;
	A02 = A02 + (x74<<2);
	A11 = A11 + x74;

	x75 = (x11<<2) - x43;
	A13 = A13 + (x75<<5);
	A14 = A14 + (x75<<3);

	x76 = x11 + (x41<<1);
	A03 = A03 - (x76<<2);
	A04 = A04 + (x76<<3);

	x77 = (x15<<5) + x41;
	A01 = A01 + x77;
	A04 = A04 - x77;

	x78 = x15 - x40;
	A07 = A07 - x78;
	A10 = A10 - (x78<<5);

	x79 = x14 - x39;
	A00 = A00 - (x79<<1);
	A13 = A13 + (x79<<1);

	x80 = x29 - x38;
	A06 = A06 + (x80<<3);
	A10 = A10 - x80;

	x81 = x12 + x37;
	A08 = A08 - (x81<<5);
	A13 = A13 + x81;

	x82 = x23 - (x37<<1);
	tmp1 = x82 + (x82<<4);
	A03 = (A03 + tmp1);

	x83 = (x14<<5) + x36;
	A01 = A01 - x83;
	A03 = A03 - (x83<<1);

	x84 = (x04<<2) - x34;
	A02 = A02 - (x84<<5);
	A11 = A11 + (x84<<1);

	x85 = (x13<<5) - x34;
	A05 = A05 + x85;
	A09 = A09 + x85;

	x86 = x08 - x33;
	tmp1 = -x86 + (x86<<4);
	A06 = (A06 - tmp1);

	x87 = x03 + x31;
	A02 = A02 - x87;
	A08 = A08 - (x87<<2);

	x88 = x07 + (x30<<3);

	x89 = x26 + x88;
	A09 = A09 - x89;
	A14 = A14 - x89;

	x90 = x21 + x30;
	A02 = A02 - x90;
	A15 = A15 - (x90<<1);

	x91 = x05 + (x29<<1);

	x92 = (x16<<1) + x91;
	A01 = A01 - (x92<<2);
	A04 = A04 + (x92<<3);

	x93 = x12 + (x25<<1);
	A01 = A01 - (x93<<1);
	A03 = A03 - x93;

	x94 = (x06<<6) + x24;
	A00 = A00 + x94;
	A12 = A12 - (x94<<1);

	x95 = x06 + (x23<<3);
	A00 = A00 + x95;
	A04 = A04 + (x95<<1);

	x96 = (x08<<1) - x21;
	A01 = A01 - (x96<<5);
	A10 = A10 - (x96<<4);

	x97 = x02 - x20;
	A04 = A04 - x97;
	A08 = A08 - x97;

	x98 = (x02<<5) - x20;
	A07 = A07 - x98;
	A14 = A14 + (x98<<1);

	tmp0 = x13 + (x13<<4);
	x99 = ((tmp0<<1) + x19);
	A01 = A01 - (x99<<1);
	A08 = A08 - x99;

	x100 = (x12<<6) + x16;
	A01 = A01 - x100;
	A12 = A12 + x100;

	x101 = x15 - (x16<<1);
	A08 = A08 - (x101<<3);
	A10 = A10 + (x101<<1);

	x102 = x00 + (x13<<3);
	A09 = A09 + x102;
	A12 = A12 + (x102<<2);
	//~code end
	AL[ 0] = A00; AL[ 1] = A01; AL[ 2] = A02; AL[ 3] = A03; 
	AL[ 4] = A04; AL[ 5] = A05; AL[ 6] = A06; AL[ 7] = A07; 
	AL[ 8] = A08; AL[ 9] = A09; AL[10] = A10; AL[11] = A11; 
	AL[12] = A12; AL[13] = A13; AL[14] = A14; AL[15] = A15; 

	//verify
	const int dim = 16;
	int bstOdd16x16[256] = {//377
 90, 90, 88, 85, 82, 78, 73, 67, 61, 54, 46, 38, 31, 22, 13,  4,
 90, 82, 67, 46, 22, -4,-31,-54,-73,-85,-90,-88,-78,-61,-38,-13,
 88, 67, 31,-13,-54,-82,-90,-78,-46, -4, 38, 73, 90, 85, 61, 22,
 85, 46,-13,-67,-90,-73,-22, 38, 82, 88, 54, -4,-61,-90,-78,-31,
 82, 22,-54,-90,-61, 13, 78, 85, 31,-46,-90,-67,  4, 73, 88, 38,
 78, -4,-82,-73, 13, 85, 67,-22,-88,-61, 31, 90, 54,-38,-90,-46,
 73,-31,-90,-22, 78, 67,-38,-90,-13, 82, 61,-46,-88, -4, 85, 54,
 67,-54,-78, 38, 85,-22,-90,  4, 90, 13,-88,-31, 82, 46,-73,-61,
 61,-73,-46, 82, 31,-88,-13, 90, -4,-90, 22, 85,-38,-78, 54, 67,
 54,-85, -4, 88,-46,-61, 82, 13,-90, 38, 67,-78,-22, 90,-31,-73,
 46,-90, 38, 54,-90, 31, 61,-88, 22, 67,-85, 13, 73,-82,  4, 78,
 38,-88, 73, -4,-67, 90,-46,-31, 85,-78, 13, 61,-90, 54, 22,-82,
 31,-78, 90,-61,  4, 54,-88, 82,-38,-22, 73,-90, 67,-13,-46, 85,
 22,-61, 85,-90, 73,-38, -4, 46,-78, 90,-82, 54,-13,-31, 67,-88,
 13,-38, 61,-78, 88,-90, 85,-73, 54,-31,  4, 22,-46, 67,-82, 90,
  4,-13, 22,-31, 38,-46, 54,-61, 67,-73, 78,-82, 85,-88, 90,-90};
	for(int ii=0; ii<dim*dim; ii++)
	{
		if(bstOdd16x16[ii] != AL[ii/dim][ii%dim])
			printf("idx %3d  value %10d %10d\n", ii, bstOdd16x16[ii], AL[ii/dim][ii%dim]);

	}
}
void vrfy_mtrx_HMOdd8x8()
{
	VECINT tmp, tmp0, tmp00, tmp000, tmp0000, tmp0001, tmp001, tmp0010, tmp0011, tmp01, tmp010, tmp0100, tmp0101, 
				 tmp011, tmp0110, tmp0111, tmp1, tmp10, tmp100,
				 tmp1000, tmp1001, tmp101, tmp1010, tmp1011, tmp11, tmp110, tmp1100, tmp1101, tmp111, tmp1110, tmp1111;
	VECINT A00, A01, A02, A03, A04, A05, A06, A07, A08, A09, A10, A11, A12, A13, A14, A15, AL[16];
	VECINT x00, x01, x02, x03, x04, x05, x06, x07, x08, x09, x10, x11, x12, x13, x14, x15;
	VECINT x16, x17, x18, x19, x20, x21, x22, x23, x24, x25, x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37, x38, x39, x40, x41, x42, x43, x44, x45,
				x46, x47, x48, x49, x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61, x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73, x74, x75,
				x76, x77, x78, x79, x80, x81, x82, x83, x84, x85, x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97, x98, x99, x100, x101, x102, x103, x104,
				x105, x106, x107, x108, x109, x110, x111, x112, x113, x114, x115, x116, x117, x118, x119, x120, x121, x122, x123, x124, x125, x126, x127;
	x00[ 0] = 1;	x01[ 1] = 1;	x02[ 2] = 1;	x03[ 3] = 1;
	x04[ 4] = 1;	x05[ 5] = 1;	x06[ 6] = 1;	x07[ 7] = 1;
	x08[ 8] = 1;	x09[ 9] = 1;	x10[10] = 1;	x11[11] = 1;
	x12[12] = 1;	x13[13] = 1;	x14[14] = 1;	x15[15] = 1;

	//code start
	A01 = -x00 + (x00<<3);
	A04 = (x00<<3) + (x00<<6);
	A07 = -(x00);

	A00 = (x01<<2);
	A01 = A01 + x01;
	A04 = A04 - (x01<<7);
	A06 = -((x01<<6));

	tmp1 = -x02 + (x02<<4);
	A00 = (A00 + (tmp1<<3));
	A05 = (x02<<6);
	A07 = A07 - (x02<<5);

	A01 = A01 - (x03<<5);
	A07 = A07 - x03;

	A00 = A00 + x04;
	A02 = -(x04);
	A03 = (x04<<4);
	tmp1 = x04 + (x04<<5);
	A05 = (A05 - (tmp1<<2));
	A06 = A06 + (x04<<5);

	A00 = A00 - (x05<<5);
	A02 = A02 + (x05<<4);
	A06 = A06 - x05;
	A07 = A07 - (x05<<6);

	A04 = A04 + (x06<<5);
	A07 = A07 + (x06<<2);

	tmp1 = x07 + (x07<<3);
	A03 = (A03 - (tmp1<<3));
	tmp1 = x07 + (x07<<2);
	A05 = (A05 - (tmp1<<4));
	A06 = A06 + (x07<<3);

	tmp0 = x03 + (x03<<1);
	tmp1 = x07 + (x07<<2);
	x08 = (tmp0 + tmp1);
	A00 = A00 + (x08<<1);
	tmp1 = x08 + (x08<<2);
	A01 = (A01 - tmp1);
	A03 = A03 + (x08<<2);
	A06 = A06 + (x08<<4);
	A07 = A07 - (x08<<1);

	tmp0 = x02 + (x02<<2);
	tmp1 = x06 + (x06<<1);
	x09 = (tmp0 - tmp1);
	A02 = A02 - (x09<<4);
	A04 = A04 - x09;
	A06 = A06 + (x09<<1);

	tmp0 = x01 + (x01<<1);
	tmp1 = x05 + (x05<<2);
	x10 = (tmp0 - tmp1);
	A02 = A02 + (x10<<2);

	tmp0 = x00 + (x00<<2);
	tmp1 = x04 + (x04<<1);
	x11 = (tmp0 + tmp1);
	tmp1 = x11 + (x11<<3);
	A00 = (A00 + (tmp1<<1));
	A04 = A04 - (x11<<2);
	A07 = A07 + (x11<<1);

	x12 = (x06<<2) - x11;
	A01 = A01 - (x12<<4);
	A06 = A06 - x12;

	x13 = (x04<<3) - x10;
	A03 = A03 + (x13<<2);

	x14 = (x03<<3) - x09;
	A04 = A04 + (x14<<2);

	x15 = (x01<<1) - x11;
	A05 = A05 - (x15<<4);

	x16 = x08 + x10;
	A02 = A02 - x16;
	A03 = A03 - x16;
	A04 = A04 + (x16<<4);

	x17 = (x06<<3) + x09;
	A02 = A02 + (x17<<1);
	A03 = A03 - (x17<<4);
	A07 = A07 + (x17<<4);

	tmp0 = -x05 + (x05<<3);
	x18 = (tmp0 + (x08<<1));
	A07 = A07 - (x18<<3);

	x19 = (x03<<4) - x18;

	x20 = x12 - x19;
	A02 = A02 + (x20<<3);
	A04 = A04 - x20;

	x21 = x02 + (x15<<1);
	tmp1 = -x21 + (x21<<3);
	A03 = (A03 - tmp1);

	x22 = (x01<<4) + x14;

	x23 = (x10<<1) - x22;
	A00 = A00 - (x23<<3);
	A05 = A05 + x23;

	x24 = x11 - (x14<<2);
	A05 = A05 - x24;
	A06 = A06 + (x24<<2);

	x25 = x01 - (x13<<3);

	x26 = (x03<<1) + x25;

	x27 = x09 + x26;
	A01 = A01 + (x27<<1);
	A07 = A07 - x27;

	x28 = x02 - (x10<<1);
	A01 = A01 - x28;
	A05 = A05 + (x28<<3);

	x29 = (x04<<1) + x10;
	A00 = A00 + x29;
	A06 = A06 - (x29<<1);

	x30 = x00 + (x07<<2);
	A02 = A02 - (x30<<3);

	x31 = x06 - x07;
	A00 = A00 + x31;
	A06 = A06 + x31;

	x32 = (x00<<5) - x03;
	A02 = A02 + (x32<<2);
	A05 = A05 - x32;
	//~code end
	AL[ 0] = A00; AL[ 1] = A01; AL[ 2] = A02; AL[ 3] = A03; 
	AL[ 4] = A04; AL[ 5] = A05; AL[ 6] = A06; AL[ 7] = A07; 
	AL[ 8] = A08; AL[ 9] = A09; AL[10] = A10; AL[11] = A11; 
	AL[12] = A12; AL[13] = A13; AL[14] = A14; AL[15] = A15; 

	//verify
	const int dim = 8;
	int bstOdd8x8[64] = {//102
 90, 87, 80, 70, 57, 43, 25,  9,
 87, 57,  9,-43,-80,-90,-70,-25,
 80,  9,-70,-87,-25, 57, 90, 43,
 70,-43,-87,  9, 90, 25,-80,-57,
 57,-80,-25, 90, -9,-87, 43, 70,
 43,-90, 57, 25,-87, 70,  9,-80,
 25,-70, 90,-80, 43,  9,-57, 87,
  9,-25, 43,-57, 70,-80, 87,-90};
	/*for(int ii=0; ii<dim; ii++)
		AL[ii].print();*/
	for(int ii=0; ii<dim*dim; ii++)
	{
		if(bstOdd8x8[ii] != AL[ii/dim][ii%dim])
			printf("idx %3d  value %10d %10d\n", ii, bstOdd8x8[ii], AL[ii/dim][ii%dim]);

	}
}
void vrfy_mtrx_HMOdd4x4()
{
	VECINT tmp, tmp0, tmp00, tmp000, tmp0000, tmp0001, tmp001, tmp0010, tmp0011, tmp01, tmp010, tmp0100, tmp0101, 
				 tmp011, tmp0110, tmp0111, tmp1, tmp10, tmp100,
				 tmp1000, tmp1001, tmp101, tmp1010, tmp1011, tmp11, tmp110, tmp1100, tmp1101, tmp111, tmp1110, tmp1111;
	VECINT A00, A01, A02, A03, A04, A05, A06, A07, A08, A09, A10, A11, A12, A13, A14, A15, AL[16];
	VECINT x00, x01, x02, x03, x04, x05, x06, x07, x08, x09, x10, x11, x12, x13, x14, x15;
	VECINT x16, x17, x18, x19, x20, x21, x22, x23, x24, x25, x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37, x38, x39, x40, x41, x42, x43, x44, x45,
				x46, x47, x48, x49, x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61, x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73, x74, x75,
				x76, x77, x78, x79, x80, x81, x82, x83, x84, x85, x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97, x98, x99, x100, x101, x102, x103, x104,
				x105, x106, x107, x108, x109, x110, x111, x112, x113, x114, x115, x116, x117, x118, x119, x120, x121, x122, x123, x124, x125, x126, x127;
	x00[ 0] = 1;	x01[ 1] = 1;	x02[ 2] = 1;	x03[ 3] = 1;
	x04[ 4] = 1;	x05[ 5] = 1;	x06[ 6] = 1;	x07[ 7] = 1;
	x08[ 8] = 1;	x09[ 9] = 1;	x10[10] = 1;	x11[11] = 1;
	x12[12] = 1;	x13[13] = 1;	x14[14] = 1;	x15[15] = 1;

	//code start
	A00 = -(x00);
	A01 = (x00<<7);

	tmp1 = x01 + (x01<<6);
	A00 = (A00 + tmp1);
	A01 = A01 - (x01<<3);
	A02 = -((x01<<6));

	A01 = A01 - (x02<<6);
	A02 = A02 + (x02<<3);
	A03 = x02 + (x02<<6);

	A02 = A02 - (x03<<3);
	A03 = A03 + x03;

	tmp0 = x01 + (x01<<2);
	tmp1 = x03 + (x03<<3);
	x04 = (tmp0 + tmp1);
	A00 = A00 + (x04<<1);
	A01 = A01 - (x04<<1);

	tmp0 = x00 + (x00<<3);
	tmp1 = x02 + (x02<<2);
	x05 = (tmp0 + tmp1);
	A02 = A02 + (x05<<1);
	A03 = A03 + (x05<<1);

	x06 = x05 + (x05<<2);
	A00 = A00 + (x06<<1);
	A01 = A01 - x06;

	x07 = x04 + (x04<<2);
	A02 = A02 - x07;
	A03 = A03 - (x07<<1);

	x08 = x00 + (x03<<2);
	A01 = A01 - (x08<<3);
	A02 = A02 + (x08<<5);
	//~code end
	AL[ 0] = A00; AL[ 1] = A01; AL[ 2] = A02; AL[ 3] = A03; 
	AL[ 4] = A04; AL[ 5] = A05; AL[ 6] = A06; AL[ 7] = A07; 
	AL[ 8] = A08; AL[ 9] = A09; AL[10] = A10; AL[11] = A11; 
	AL[12] = A12; AL[13] = A13; AL[14] = A14; AL[15] = A15; 

	//verify
	const int dim = 4;
	int bstOdd4x4[16] = {//27
 89, 75, 50, 18,
 75,-18,-89,-50,
 50,-89, 18, 75,
 18,-50, 75,-89};
	for(int ii=0; ii<dim*dim; ii++)
	{
		if(bstOdd4x4[ii] != AL[ii/dim][ii%dim])
			printf("idx %3d  value %10d %10d\n", ii, bstOdd4x4[ii], AL[ii/dim][ii%dim]);

	}
}